/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataplexAspectTypeIamMemberConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member#aspect_type_id DataplexAspectTypeIamMember#aspect_type_id}
    */
    readonly aspectTypeId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member#id DataplexAspectTypeIamMember#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member#location DataplexAspectTypeIamMember#location}
    */
    readonly location?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member#member DataplexAspectTypeIamMember#member}
    */
    readonly member: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member#project DataplexAspectTypeIamMember#project}
    */
    readonly project?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member#role DataplexAspectTypeIamMember#role}
    */
    readonly role: string;
    /**
    * condition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member#condition DataplexAspectTypeIamMember#condition}
    */
    readonly condition?: DataplexAspectTypeIamMemberCondition;
}
export interface DataplexAspectTypeIamMemberCondition {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member#description DataplexAspectTypeIamMember#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member#expression DataplexAspectTypeIamMember#expression}
    */
    readonly expression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member#title DataplexAspectTypeIamMember#title}
    */
    readonly title: string;
}
export declare function dataplexAspectTypeIamMemberConditionToTerraform(struct?: DataplexAspectTypeIamMemberConditionOutputReference | DataplexAspectTypeIamMemberCondition): any;
export declare function dataplexAspectTypeIamMemberConditionToHclTerraform(struct?: DataplexAspectTypeIamMemberConditionOutputReference | DataplexAspectTypeIamMemberCondition): any;
export declare class DataplexAspectTypeIamMemberConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataplexAspectTypeIamMemberCondition | undefined;
    set internalValue(value: DataplexAspectTypeIamMemberCondition | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _expression?;
    get expression(): string;
    set expression(value: string);
    get expressionInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member google_dataplex_aspect_type_iam_member}
*/
export declare class DataplexAspectTypeIamMember extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_dataplex_aspect_type_iam_member";
    /**
    * Generates CDKTF code for importing a DataplexAspectTypeIamMember resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataplexAspectTypeIamMember to import
    * @param importFromId The id of the existing DataplexAspectTypeIamMember that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataplexAspectTypeIamMember to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google/5.31.1/docs/resources/dataplex_aspect_type_iam_member google_dataplex_aspect_type_iam_member} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataplexAspectTypeIamMemberConfig
    */
    constructor(scope: Construct, id: string, config: DataplexAspectTypeIamMemberConfig);
    private _aspectTypeId?;
    get aspectTypeId(): string;
    set aspectTypeId(value: string);
    get aspectTypeIdInput(): string | undefined;
    get etag(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    resetLocation(): void;
    get locationInput(): string | undefined;
    private _member?;
    get member(): string;
    set member(value: string);
    get memberInput(): string | undefined;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _condition;
    get condition(): DataplexAspectTypeIamMemberConditionOutputReference;
    putCondition(value: DataplexAspectTypeIamMemberCondition): void;
    resetCondition(): void;
    get conditionInput(): DataplexAspectTypeIamMemberCondition | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
